//// MxWoW Official Module
//// Portal Master
//// Dev:       mikx
//// Git:       https://mxgit.ovh/MxWoW/mod_mxwow_portalmaster
//// Credits:   Based on https://github.com/azerothcore/mod-character-tools

#include "Define.h"
#include "GossipDef.h"
#include "Item.h"
#include "Player.h"
#include "ScriptedGossip.h"
#include "ScriptMgr.h"
#include "Spell.h"
#include "Configuration/Config.h"
#include "Chat.h"

class mxwow_portalmasterAnnounce : public PlayerScript
{
    public:
    mxwow_portalmasterAnnounce() : PlayerScript("mxwow_portalmasterAnnounce") {}
    void OnLogin(Player* player) override
    {
        // Announce Module
        if (!sConfigMgr->GetOption<bool>("MxWoW_PortalMaster.Enabled", true))
        {
            if (!sConfigMgr->GetOption<bool>("MxWoW_PortalMaster.Announce", true))
            {
                ChatHandler(player->GetSession()).SendSysMessage("This server is running the |cf5a1b00MxW|r - |cff4CFF00Portal Master |rmodule.");
            }
        }
    }
};

class mxwow_portalmaster : public ItemScript
{
public:
    mxwow_portalmaster() : ItemScript("mxwow_portalmaster") {}   

    bool OnUse(Player *p, Item *i, SpellCastTargets const & /*targets*/) override
    {
        p->PlayerTalkClass->ClearMenus();

        if (p->IsInCombat())
            return false;

        if (!sConfigMgr->GetOption<bool>("MxWoW_PortalMaster.Enabled", true))
            return false;

        AddGossipItemFor(p, GOSSIP_ICON_CHAT, "|TInterface/Icons/spell_arcane_portalstormwind:50:50|tPortal: Stormwind (Hurlevent)", GOSSIP_SENDER_MAIN, 1);
        AddGossipItemFor(p, GOSSIP_ICON_CHAT, "|TInterface/Icons/spell_arcane_portalironforge:50:50|tPortal: Ironforge (Forgefer)", GOSSIP_SENDER_MAIN, 2);
        AddGossipItemFor(p, GOSSIP_ICON_CHAT, "|TInterface/Icons/spell_arcane_portaldarnassus:50:50|tPortal: Darnassus", GOSSIP_SENDER_MAIN, 3);
        AddGossipItemFor(p, GOSSIP_ICON_CHAT, "|TInterface/Icons/spell_arcane_portalexodar:50:50|tPortal: Exodar", GOSSIP_SENDER_MAIN, 4);
        AddGossipItemFor(p, GOSSIP_ICON_CHAT, "|TInterface/Icons/spell_arcane_portaltheramore:50:50|tPortal: Theramore", GOSSIP_SENDER_MAIN, 5);
        AddGossipItemFor(p, GOSSIP_ICON_CHAT, "|TInterface/Icons/spell_arcane_portalshattrath:50:50|tPortal: Shattrath", GOSSIP_SENDER_MAIN, 6);
        AddGossipItemFor(p, GOSSIP_ICON_CHAT, "|TInterface/Icons/spell_arcane_portaldalaran:50:50|tPortal: Dalaran", GOSSIP_SENDER_MAIN, 7);
        SendGossipMenuFor(p, DEFAULT_GOSSIP_MESSAGE, i->GetGUID());

        return false; // If item has spell cast it normal.
    }

    void OnGossipSelect(Player *player, Item * /*item*/, uint32 /*sender*/, uint32 action) override
    {
        player->PlayerTalkClass->ClearMenus();
        switch (action)
        {
        case 1:
            player->CastSpell(player, 10059, true);
            break;
        case 2:
            player->CastSpell(player, 11416, true);
            break;
        case 3:
            player->CastSpell(player, 11419, true);
            break;
        case 4:
            player->CastSpell(player, 32266, true);
            break;
        case 5:
            player->CastSpell(player, 49360, true);
            break;
        case 6:
            player->CastSpell(player, 33691, true);
            break;
        case 7:
            player->CastSpell(player, 53142, true);
            break;
        }
    }
};

void AddMxWoWPortalMasterScripts()
{
    new mxwow_portalmasterAnnounce();
    new mxwow_portalmaster();
}
